import { getUrl as publicGetUrl, getPurchaseHistory as publicGetPurchaseHistory, getMeteredBillingCharges as publicGetMeteredBillingCharges } from './devcenter-checkout-v1-purchased-item-billing.public.js';
import { createEventModule } from '@wix/sdk-runtime/event-definition-modules';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
import { onPurchasedItemInvoiceStatusUpdated as publicOnPurchasedItemInvoiceStatusUpdated } from './devcenter-checkout-v1-purchased-item-billing.public.js';
export declare const getUrl: MaybeContext<BuildRESTFunction<typeof publicGetUrl> & typeof publicGetUrl>;
export declare const getPurchaseHistory: MaybeContext<BuildRESTFunction<typeof publicGetPurchaseHistory> & typeof publicGetPurchaseHistory>;
/** @internal */
export declare const getMeteredBillingCharges: MaybeContext<BuildRESTFunction<typeof publicGetMeteredBillingCharges> & typeof publicGetMeteredBillingCharges>;
/**
 * Triggered when there is an update to the payment status of an invoice.
 * Charges made using the [Custom Charges SPI](https://dev.wix.com/docs/rest/app-management/app-billing/custom-charges-service-plugin/introduction) may be based on usage.
 * Learn more about [usage-based charges](https://dev.wix.com/docs/build-apps/launch-your-app/pricing-and-billing/set-up-a-usage-based-business-model).
 */
export declare const onPurchasedItemInvoiceStatusUpdated: ReturnType<typeof createEventModule<typeof publicOnPurchasedItemInvoiceStatusUpdated>>;
export { PaymentCycle, InvoiceStatus, WebhookIdentityType, } from './devcenter-checkout-v1-purchased-item-billing.universal.js';
export { PurchasedItem, InvoiceStatusUpdated, GetUrlRequest, ChargeOverride, GetUrlResponse, GetPurchaseHistoryRequest, GetPurchaseHistoryResponse, GetSitePaymentMethodsStatusRequest, GetSitePaymentMethodsStatusResponse, GetMeteredBillingChargesRequest, GetMeteredBillingChargesResponse, Charge, MessageEnvelope, IdentificationData, IdentificationDataIdOneOf, BaseEventMetadata, PurchasedItemInvoiceStatusUpdatedEnvelope, GetUrlOptions, GetMeteredBillingChargesOptions, } from './devcenter-checkout-v1-purchased-item-billing.universal.js';
